#ifndef __SEND_CHAIN__
#define __SEND_CHAIN__

class PacketInChain
{
friend class PacketChain;
public:
	PacketInChain() { type_ = -1; next_=NULL; interval_ = -1;}
	PacketInChain(int type, int seq) { type_ = type; seq_ = seq; next_=NULL; interval_ = -1; }
	~PacketInChain() {};

	int type() { return type_; }
	int seq() { return seq_; }
	double interval() { return interval_; }

protected:
	int type_;		// 0->whole packet, i->i th fragment (i>0)
	int seq_;			// sequence number of the packet
	double interval_;

	PacketInChain *next_;
};

class PacketChain
{
public:
	PacketChain();
	~PacketChain();
	void add_pkt(int type, int seq, double delay);
	PacketInChain *head_pkt() { return head_->next_; };
	PacketInChain *pop_pkt();
	bool isempty() { if(head_->next_) return true; else return false; }
protected:
	PacketInChain *head_;
};

#endif

